commit 614a9580d4463c4aefd74c40ed46bfab2bef65c7
Author: Patrick Palka <ppalka@redhat.com>
Date:   Tue Jan 11 19:00:48 2022

    c++: dependent bases and 'this' availability [PR103831]
    
    Here during satisfaction of B's constraints we're failing to reject the
    object-less call to the non-static member function A::size ultimately
    because satisfaction is performed in the (access) context of the class
    template B, which has a dependent base, and so the any_dependent_bases_p
    check within build_new_method_call causes us to not reject the call.
    (Subsequent constexpr evaluation of the call succeeds since the function
    is effectively static.)
    
    This patch fixes this by refining the any_dependent_bases_p check within
    build_new_method_call: if we're in a context where 'this' is unavailable,
    then we cannot resolve the implicit object regardless of the presence of
    a dependent base.  So let's also check current_class_ptr alongside a_d_b_p.
    
            PR c++/103831
    
    gcc/cp/ChangeLog:
    
            * call.c (build_new_method_call): Consider dependent bases only
            if 'this' is available.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp2a/concepts-class3.C: New test.
            * g++.dg/template/non-dependent18.C: New test.
    
    (cherry picked from commit 0378f563b0321c44c4a9c98cf46d2a22b9160f76)

diff --git a/gcc/cp/call.c b/gcc/cp/call.c
index a199ae9fa71..81b0d0f27ff 100644
--- a/gcc/cp/call.c
+++ b/gcc/cp/call.c
@@ -10793,7 +10793,7 @@ build_new_method_call_1 (tree instance, tree fns, vec<tree, va_gc> **args,
 		     we know we really need it.  */
 		  cand->first_arg = instance;
 		}
-	      else if (any_dependent_bases_p ())
+	      else if (current_class_ptr && any_dependent_bases_p ())
 		/* We can't tell until instantiation time whether we can use
 		   *this as the implicit object argument.  */;
 	      else
diff --git a/gcc/testsuite/g++.dg/cpp2a/concepts-class3.C b/gcc/testsuite/g++.dg/cpp2a/concepts-class3.C
new file mode 100644
index 00000000000..68b50b71278
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/concepts-class3.C
@@ -0,0 +1,12 @@
+// PR c++/103831
+// { dg-do compile { target c++20 } }
+
+struct A {
+  constexpr int size() { return 42; } // non-static
+};
+
+template<class T>
+  requires (T::size() == 42) // { dg-error "without object" }
+struct B : T { };
+
+template struct B<A>; // { dg-error "constraint" }
